echo off
rem #************************************************************ 
rem #
rem # Component      Multi protocol command line manager
rem #
rem # Synopsis       easymanager startup script 
rem #
rem # Copyright 2001 Sun Microsystems, Inc. All rights reserved.
rem #
rem # ident  "@(#)ma 1.8     01/06/06 SMI"
rem #
rem ###############################################################################

::  ---------------
:: | Java setting  |
::  ---------------
if defined JAVA_HOME goto continue1

echo "Please set JAVA_HOME before launching easymanager."
exit /B 1

:continue1
set JDMK_HOME=..\..\..\
if "%1%" == "-h" goto printHelp

if "%JDMK_HOME%" == "" goto printJdmkHome

if "%SNMPV3_FILE%" == "" echo WARNING : SNMPV3_FILE var env not set, using etc directory one.
	set SNMPV3_FILE=..\etc\jdmk.security

if "%1" == "-t" goto JdmkDebug

:LaunchIt

:: jmx jar
set jmxri_jar=%JDMK_HOME%\lib\jmx.jar
set jmx_jar=%jmxri_jar%

:: Jdmkrt jar file
set jdmk_rt_jar=%JDMK_HOME%\lib\jdmkrt.jar

:: jeasymanager jar
set jeasymanager_jar=..\lib\easymanager.jar

set CLASSPATH_OPT=-classpath
set CLASSPATH_VALUE=%classpath%;.;%jmx_jar%;%jeasymanager_jar%;%jdmk_rt_jar%
set SECURITY_FILE=-Djdmk.security.file
set EASYMANAGER=com.sun.management.snmp.easymanager.SimpleManager
"%JAVA_HOME%\bin\java" %DEB% %CLASSPATH_OPT% %CLASSPATH_VALUE% %SECURITY_FILE%=%SNMPV3_FILE% %EASYMANAGER% %1 %2 %3 %4 %5
goto end

:JdmkDebug
set DEB=-DLEVEL_DEBUG 
shift
goto LaunchIt

:printHelp
echo easymanager is a simple SNMP V1, V2 and V3 command line manager
echo based on JDMK. Type help on command line to display commands.
echo usage : easymanager {-t} {-crypto} {-host agent host} {-port agent port}
echo -t         : To activate debug outputs.
echo -crypto    : To activate cryptographie.
echo -host agent host : The agent host. The default value is localhost.
echo -port agent port : The agent port. The default value is 8085. Traps are 
echo  received on agent port + 1 (default value 8086).
echo  It allows you to:
echo  * Quickly test your development.
echo  * Load mib table symbols. MIB II is loaded by default. MIB tables are
echo    looked for in easymanager CLASSPATH then in your CLASSPATH.
echo  * Send get, getnext, getbulk, set requests in SNMP V1, V2 and V3.
echo  * Load your own SNMP V3 security file. You need to set EM_SFILE env 
echo    to your JDMK security file full name.
echo  * Receive trap and informs in a separate window.

:printJdmkHome
echo JDMK_HOME is not set....
:end
set DEB=
