/*
 * @(#)file      MibFrame.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.6
 * @(#)date      04/07/05
 *
 * Copyright 2000-2004 Sun Microsystems, Inc.  All rights reserved.
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 * 
 * Copyright 2000-2004 Sun Microsystems, Inc.  Tous droits r?serv?s.
 * Ce logiciel est propriet? de Sun Microsystems, Inc.
 * Distribu? par des licences qui en restreignent l'utilisation. 
 *
 */
package com.sun.management.snmp.easymanager;

import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;

import java.net.InetAddress;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;

import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import javax.swing.tree.TreeSelectionModel;
import java.awt.TextArea;
import java.awt.Frame;
import java.awt.Panel;
import java.awt.Button;
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.BorderLayout;
import java.awt.TextField;
import java.awt.Label;
import java.awt.FlowLayout;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.awt.List;
import javax.swing.BoxLayout;
import com.sun.management.snmp.manager.SnmpRequestHandler;
import com.sun.management.snmp.SnmpOid;
import com.sun.management.snmp.SnmpVarBindList;
import com.sun.management.snmp.SnmpVarBind;
import com.sun.management.snmp.SnmpOidRecord;
import com.sun.management.snmp.SnmpValue;
import com.sun.management.snmp.SnmpCounter;
import com.sun.management.snmp.SnmpCounter64;
import com.sun.management.snmp.SnmpGauge;
import com.sun.management.snmp.SnmpInt;
import com.sun.management.snmp.SnmpIpAddress;
import com.sun.management.snmp.SnmpNull;
import com.sun.management.snmp.SnmpOid;
import com.sun.management.snmp.SnmpOpaque;
import com.sun.management.snmp.SnmpString;
import com.sun.management.snmp.SnmpStringFixed;
import com.sun.management.snmp.SnmpTimeticks;
import com.sun.management.snmp.SnmpUnsignedInt;
import com.sun.management.snmp.SnmpStatusException;
import com.sun.management.snmp.SnmpDefinitions;

import com.sun.management.snmp.manager.SnmpPeer;
import com.sun.management.snmp.manager.SnmpRequest;
import com.sun.management.snmp.manager.SnmpSession;


class SetRow extends Panel {
    TextField field = null;
    String oid = null;
    SnmpValue val = null;
    MibFrame frame = null;
    SetRow(String oid, SnmpValue val, MibFrame frame) {
	this.oid = oid;
	this.val = val;
	this.frame = frame;
	setLayout(new FlowLayout());
	add(new Label(oid + " ("+ val.getTypeName() + ")"+ ": "));
	field = new TextField("", 20);
	add(field);
	setVisible(true);
    }

    SnmpValue getValue() { return translateValue(field.getText()); }
    
    private SnmpValue translateValue(String value) {
	try {
	    if(val instanceof SnmpCounter) 
		return new SnmpCounter(Integer.parseInt(value));
	    if(val instanceof SnmpCounter64)
		return new SnmpCounter64(Long.parseLong(value));
	    if(val instanceof SnmpGauge)
		return new SnmpGauge(Long.parseLong(value));
	    if(val instanceof SnmpInt)
		return new SnmpInt(Long.parseLong(value));
	    if(val instanceof SnmpIpAddress)
		return new SnmpIpAddress(value);
	    if(val instanceof SnmpNull)
		return new SnmpNull(Integer.parseInt(value));
	    if(val instanceof SnmpOid)
		return new SnmpOid(value);
	    if(val instanceof SnmpOpaque)
		return new SnmpOpaque(value);
	    if(val instanceof SnmpString)
		return new SnmpString(value);
	    if(val instanceof SnmpStringFixed)
		return new SnmpStringFixed(value);
	    if(val instanceof SnmpTimeticks)
		return new SnmpTimeticks(Long.parseLong(value));
	    return null;
	}catch(Throwable e) {
	    frame.text.append("-------------[EXCEPTION]-------------\n");
	    frame.text.append("Not a right value [" + e.getMessage() + "]\n");
	    return null;
	}
    }
}


// NO MORE USED BECAUSE PROFILE USED IS THE DEFAULT ONE.
class GetFrame extends Frame implements ActionListener  {
    MibFrame frame = null;
    List l = null;
    Button b = null;
    Vector v = null;
    GetFrame(Vector v, 
	     MibFrame frame) {
	this.v = v;
	this.frame = frame;
	Panel p = new Panel();
	p.setLayout(new BorderLayout());
	p.add(new Label("Profile to use : "), BorderLayout.NORTH);
	l = new List();
	for(Enumeration e = frame.m.profiles.keys(); e.hasMoreElements();) {
	    String key = (String) e.nextElement();
	    l.add(key);
	}
	p.add(l, BorderLayout.SOUTH);
	setLayout(new BorderLayout());
	add(p, BorderLayout.NORTH);
	b = new Button("Ok");
	b.addActionListener(this);
	add(b, BorderLayout.SOUTH);
	pack();
	show();
    }
    
    public void actionPerformed(ActionEvent ev) {
	//if(ev.getSource() == b) 
	    //frame.getValues(l.getSelectedItem(), v);
	    //frame.getValues(v);
    }
}

class SetFrame extends Frame implements ActionListener  {
    Vector rows = new Vector();
    MibFrame frame = null;
    List l = null;
    SetFrame(Vector set, MibFrame frame) {
	this.frame = frame;
	setLayout(new BorderLayout());
	Panel p = new Panel();
	p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
	//p.add(new Label("Profile to use : "));
	//l = new List();
	//for(Enumeration e = frame.m.profiles.keys(); e.hasMoreElements();) {
	//    String key = (String) e.nextElement();
	//    l.add(key);
	//}
	//p.add(l);
	add(p, BorderLayout.NORTH);
	Button b  = new Button("Ok");
	b.addActionListener(this);
	add(b, BorderLayout.SOUTH);
	for(Enumeration e = set.elements(); e.hasMoreElements();) {
	    OidNode node = (OidNode) e.nextElement();
	    SetRow row = new SetRow(node.name, node.val, frame);
	    rows.add(row);
	    p.add(row);
	}
	pack();
	show();
    }
    public void actionPerformed(ActionEvent ev) {
	//frame.setValues(l.getSelectedItem(),
	//rows);
	frame.setValues(rows);
    }
}

class MouseListenerImpl implements MouseListener {
    JTree tree = null;
    JPopupMenu popup = null;
    JPopupMenu resyncPopup = null;
    MouseListenerImpl(JTree tree, JPopupMenu popup, JPopupMenu resyncPopup) {
	this.tree = tree;
	this.popup = popup;
	this.resyncPopup = resyncPopup;
    }
    
    public void mouseClicked(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mousePressed(MouseEvent e) {
	maybeShowPopup(e);
    }

    public void mouseReleased(MouseEvent e) {
	maybeShowPopup(e);
    }

    private void maybeShowPopup(MouseEvent e) {
	DefaultMutableTreeNode node = (DefaultMutableTreeNode)
	    tree.getLastSelectedPathComponent();
	if(node != null) {
	    Object obj = node.getUserObject();
	    if(obj instanceof OidNode) {
		if (e.isPopupTrigger()) {
		    popup.show(e.getComponent(),
			       e.getX(), e.getY());
		}
	    }
	    if( (obj instanceof GroupNode) ||
		(obj instanceof TableNode) ) {
		if (e.isPopupTrigger()) {
		    resyncPopup.show(e.getComponent(),
				     e.getX(), e.getY());
		}
	    }
	}
    }
}

class TreeSelectionListenerImpl implements TreeSelectionListener {
    JTree tree = null;
    public void valueChanged(TreeSelectionEvent e) {
    }
    
    TreeSelectionListenerImpl(JTree tree) {
	this.tree = tree;
    }
}

class EntryNode {
    public DefaultMutableTreeNode node = null;
    public String index = null;
    public String name = null;
    public Hashtable oids = new Hashtable();
    public MibFrame frame = null;
    public EntryNode(MibFrame frame,
		     String entry,
		     String index) {
	SnmpOidRecord r = null;
	try {
	    r = frame.m.oidDatabase.resolveVarOid(entry);
	}catch(Exception e) {}	
	if(r != null)
	    name = r.getName();
	else
	    name = entry;
	
	this.index = index;
	this.frame = frame;
	node = new DefaultMutableTreeNode(name +"["+ index + "]");
    }

    public void addOid(String oid, SnmpValue val) {
	SnmpOidRecord r = null;
	OidNode tmp = (OidNode) oids.get(oid);
	if(tmp == null) {
	    try {
		r = frame.m.oidDatabase.resolveVarOid(oid);
	    }catch(Exception e) {}	
	    String name = null;
	    if(r != null)
		name = r.getName();
	    else
		name = oid;
	    
	    OidNode o = new OidNode(oid + "." + index, name, val);
	    oids.put(oid, o);
	    node.add(o.node);
	}
	else
	    tmp.update(val);
    }

    protected void finalize() {	
	//java.lang.System.out.println("FINALIZING : "+ node.getUserObject());
	oids.clear();
    }
}

class TableNode {
    public DefaultMutableTreeNode node = null;
    public String oid = null;
    public String name = null;
    public GroupNode group = null;
    public Hashtable entries = new Hashtable();
    public MibFrame frame = null;
    public TableNode(GroupNode group,
		     MibFrame frame,		     
		     String oid,
		     String name) {
	this.group = group;
	this.oid = oid;
	this.name = name;
	this.frame = frame;
	node = new DefaultMutableTreeNode(this);
    }
    
    public String toString() {
	return name;
    }

    public void addEntry(String entry, 
			 String field, 
			 String index, 
			 SnmpValue val) {
	EntryNode tmp = (EntryNode) entries.get(index);
	if(tmp == null) {
	    tmp = new EntryNode(frame, entry, index);
	    entries.put(index, tmp);
	    node.add(tmp.node);
	}
	tmp.addOid(field, val);	
    }

    protected void finalize() {	
	//java.lang.System.out.println("FINALIZING : "+ node.getUserObject());
	entries.clear();
    }
}

class OidNode {
    public DefaultMutableTreeNode node = null;
    public String oid = null;
    public String name = null;
    public SnmpValue val = null;
    public OidNode(String oid,
		   String name,
		   SnmpValue val) {
	this.oid = oid;
	this.name = name;
	this.val = val;
	//node = new DefaultMutableTreeNode(name + " : " + val);
    	node = new DefaultMutableTreeNode(this);
    }
    
    public String toString() {
	return name + " : " + val;
    }
    public void update(SnmpValue newVal) {
	node.setUserObject(name + " : " + newVal);
    }
    
    protected void finalize() {	
	//java.lang.System.out.println("FINALIZING : "+ node.getUserObject());
    }
}

class GroupNode {
    public DefaultMutableTreeNode node = null;
    public String name = null;
    public String radical = null;
    public Hashtable oids = new Hashtable();
    public Hashtable tables = new Hashtable();
    public MibFrame frame = null;
    public GroupNode(MibFrame frame,
		     DefaultMutableTreeNode top,
		     String radical) {
	this.radical = radical;
	SnmpOidRecord r = null;
	try {
	    r = frame.m.oidDatabase.resolveVarOid(radical);
	}catch(Exception e) {}	
	
	if(r != null) 
	    this.name = r.getName();
	else
	    this.name = "group : " + radical;
	
	this.frame = frame;
	node = new DefaultMutableTreeNode(this);
	top.add(node);
	DefaultTreeModel model = (DefaultTreeModel) frame.tree.getModel();
	model.nodeStructureChanged(top);
	TreePath path = new TreePath(node.getPath());
	frame.tree.expandPath(path);     
    }

    public String toString() {
	return name;
    }

    public void addEntry(String oid, 
			 String entry, 
			 String field,
			 String index, 
			 SnmpValue val) {
	SnmpOidRecord r = null;
	TableNode tmp = (TableNode) tables.get(oid);
	if(tmp == null) {
	    try {
		r = frame.m.oidDatabase.resolveVarOid(oid);
	    }catch(Exception e) {}	
	    String name = null;
	    if(r != null)
		name = r.getName();
	    else
		name = oid;
	    
	    tmp = new TableNode(this, frame, oid, name);
	    tables.put(oid, tmp);
	    node.add(tmp.node);
	}
	tmp.addEntry(entry, field, index, val);
    }
    
    public void addOid(String oid, SnmpValue val) {
	SnmpOidRecord r = null;
	OidNode tmp = (OidNode) oids.get(oid);
	if(tmp == null) {
	    String radicalOid = oid.substring(0, oid.length()-2);
	    try {
		r = frame.m.oidDatabase.resolveVarOid(radicalOid);
	    }catch(Exception e) {}	
	    String name = null;
	    if(r != null)
		name = r.getName();
	    else
		name = oid;
	    
	    OidNode o = new OidNode(oid, name, val);
	    oids.put(oid, o);
	    node.add(o.node);
	}
	else
	    tmp.update(val);
    }
    
    protected void finalize() {	
	//java.lang.System.out.println("FINALIZING : "+ node.getUserObject());
	oids.clear();
	tables.clear();
    }
}

class MibFrame extends Frame implements ActionListener {
    SnmpOid start = null;
    SnmpOid stop = null;
    SnmpPeer peer = null;
    SnmpSession session = null;
    SimpleManager m = null;
    Hashtable nodes = new Hashtable();
    public TextArea text = new TextArea(5, 30);
    public Button resync = new Button("resync");
    public Button close = new Button("close");
    public JTree tree = null;
    public JScrollPane treeView = null;
    public DefaultMutableTreeNode top =null;
    public JPopupMenu popup = null;
    public JPopupMenu resyncPopup = null;
    public JMenuItem menuItemOid = null;
    public JMenuItem menuItemGet = null;
    public JMenuItem menuItemSet = null;
    public JMenuItem menuItemResync = null;
    public SetFrame setFrame = null;
    public GetFrame getFrame = null;
    Panel buttons = null;
    public TrapFrame traps = null;
    private String profile;
    private class Resync extends Thread {
	SnmpOid startOid;
	SnmpOid stopOid;
	boolean complete;
	public Resync(SnmpOid startOid, SnmpOid stopOid, boolean complete) {
	    this.complete = complete;
	    this.startOid = startOid;
	    this.stopOid = stopOid;
	}
	
	public void run() {
	    asyncResync(startOid, stopOid, complete);
	}
    }

    public MibFrame(SimpleManager m,
		    SnmpPeer p,
		    SnmpSession session,
		    String start,
		    String stop,
		    TrapFrame traps) {
	super(p.getDestAddr().getHostName() +":"+ p.getDestPort());
	init(m, p, session, start, stop);
	
	buttons.add(traps.text, BorderLayout.SOUTH);
	
	pack();
    }
    
    public MibFrame(SimpleManager m,
		    SnmpPeer p,
		    SnmpSession session,
		    String start,
		    String stop) {
	super("From " + start +" to " + stop);
	init(m, p, session, start, stop);
	pack();
    }
    
    void setProfile(String profile) {
	this.profile = profile;
    }
    
    void setPeer(SnmpPeer peer) {
	this.peer = peer;
    }

    private void init(SimpleManager m,
		      SnmpPeer p,
		      SnmpSession session,
		      String start,
		      String stop) {
	this.m = m;
	this.start = new SnmpOid(start);
	this.stop = new SnmpOid(stop);
	
	this.setLayout(new BorderLayout());
	this.peer = p;
	this.session = session;
	text.setEditable(false);

	//Create the popup menu.
	popup = new JPopupMenu();
	menuItemOid = new JMenuItem("Show oid");
	menuItemOid.addActionListener(this);
	popup.add(menuItemOid);
	menuItemGet = new JMenuItem("Resync");
	menuItemGet.addActionListener(this);
	popup.add(menuItemGet);
	menuItemSet = new JMenuItem("Change value");
	menuItemSet.addActionListener(this);
	popup.add(menuItemSet);
	resyncPopup = new JPopupMenu();
	menuItemResync = new JMenuItem("Resync");
	menuItemResync.addActionListener(this);
	resyncPopup.add(menuItemResync);
	handleTree();
	Panel skel = new Panel();
	Panel top = new Panel();
	skel.setLayout(new BorderLayout());
	top.setLayout(new BorderLayout());
	top.add(text, BorderLayout.SOUTH);
	top.add(treeView, BorderLayout.NORTH);
	buttons = new Panel();
	buttons.setLayout(new BorderLayout());
	buttons.add(resync, BorderLayout.NORTH);
	buttons.add(close, BorderLayout.CENTER);
	add(buttons, BorderLayout.SOUTH);
	close.addActionListener(this);
	resync.addActionListener(this);
	
	skel.add(top, BorderLayout.NORTH);
	skel.add(buttons, BorderLayout.SOUTH);
	add(skel, BorderLayout.NORTH);
	setSize(350, 350);
    }

    private void handleTree() {
	top = new DefaultMutableTreeNode("Discovered objects");
	tree = new JTree(top);
	tree.getSelectionModel().setSelectionMode
	    (TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);//SINGLE_TREE_SELECTION 
	//Create the scroll pane and add the tree to it. 
	treeView = new JScrollPane(tree);
	Dimension minimumSize = new Dimension(100, 50);
        treeView.setMinimumSize(minimumSize);
	tree.addTreeSelectionListener(new TreeSelectionListenerImpl(tree));
	tree.addMouseListener(new MouseListenerImpl(tree, popup, resyncPopup));
    }
    
    public void clear() {
        top.removeAllChildren();
	nodes.clear();
	DefaultTreeModel model = (DefaultTreeModel) tree.getModel();
        model.reload();
	
    }
    
    private SnmpOid getNext(SnmpSession session,
			    SnmpOid oid) throws SnmpStatusException  {
	SnmpVarBindList l = new SnmpVarBindList();
	SnmpVarBind var = new SnmpVarBind(oid);
	l.addVarBind(var);
	SnmpVarBindList resp = getNext(session, l);
	
	return resp.getVarBindAt(0).getOid();
    }

    private SnmpVarBindList getNext(SnmpSession session, 
				    SnmpVarBindList vblst) 
	throws SnmpStatusException {
	
	SnmpRequest request = null;
	if(peer == null) 
	    request = session.snmpGetNextRequest(null,
						 vblst);
	else
	    request = session.snmpGetNextRequest(peer,
						 null,
						 vblst);
	
	final boolean completed = request.waitForCompletion(10000);
	
	// Check for a timeout of the request.
	//
	if (completed == false) {
	    text.append("GetNext Request timed out." +
			" Check reachability of agent\n");
	    throw new SnmpStatusException("GetNext Request timed out. " + 
					  "Check reachability of agent");
	}
	
	// Now we have a response. Check if the response contains 
	// an error.
	//
	final int errorStatus = request.getErrorStatus();
	
	if (errorStatus != SnmpDefinitions.snmpRspNoError) {
	    text.append("Snmp error, error [" +  
			SnmpRequest.snmpErrorToString(errorStatus) +
			" ] index [" + request.getErrorIndex() + "]\n");
	    
	    throw new SnmpStatusException("GetNext request. error [" +  
					  SnmpRequest.snmpErrorToString(errorStatus) +
					  " ] index [" + 
					  request.getErrorIndex() + "]");
	}
	
	final SnmpVarBindList result = request.getResponseVarBindList();
	
	return result;
    }

    private void hookInTree(SnmpVarBindList response) {
	int size = response.getVarBindCount();
	
	for (int i = 0; i < size; i++) {
	    SnmpVarBind b = response.getVarBindAt(i);
	    
	    String oid = b.getOid().toString();
	    //Look for groups radical
	    if(oid.endsWith(".0") && !isEntry(oid)) {
		String radical = reconstructOid(oid, 2);
		GroupNode node = (GroupNode) nodes.get(radical);
		if(node == null) {
		    //text.append("New group : " + radical + "\n");
		    node = new GroupNode(this,
					 top, 
					 radical);
		    nodes.put(radical, node);
		}
		//else
		//  text.append("Already discovered group : " + radical + "\n");
		// Add oid in group
		node.addOid(oid, b.getSnmpValue());
	    } 
	    else {
		// Table processing
		for(Enumeration e = m.metaFinder.entries.elements();
		    e.hasMoreElements();) {
		    String entry = ((SnmpOidRecord) e.nextElement()).getOid();
		    if(oid.startsWith(entry)) {
			//Compute field
			long[] lentry = new SnmpOid(entry).longValue();
			long[] loid = b.getOid().longValue();
			long f = loid[lentry.length];
			long[] fieldOid = new long[lentry.length + 1];
			java.lang.System.arraycopy(lentry, 0, fieldOid, 0, lentry.length);
			fieldOid[lentry.length] = f;
			String field = new SnmpOid(fieldOid).toString();
			// Compute index
			int indexSize = loid.length - fieldOid.length;
			long[] lindex = new long[indexSize];
			for(int j= 0; j < indexSize; j++) {
			    lindex[j] = loid[fieldOid.length + j];
			}
			
			String index = new SnmpOid(lindex).toString();
			   
			//text.append("INDEX : " + index);
			
			//text.append("FIELD : " + field);
			
			String tableOid = reconstructOid(entry, 1);
			String groupOid = reconstructOid(entry, 2);
			GroupNode node = (GroupNode) nodes.get(groupOid);
			if(node == null) {
			    //text.append("New group : " + groupOid + "\n");
			    node = new GroupNode(this,
						 top, 
						 groupOid);
			    nodes.put(groupOid, node);
			} 
			//else
			//  text.append("Already discovered group : " + groupOid + "\n");
			node.addEntry(tableOid, 
				      entry,
				      field,
				      index, 
				      b.getSnmpValue());
			break;
		    }
		}
	    }
	}
    }

    private void doitWithGetNext(SnmpSession session,
				 SnmpVarBindList list,
				 SnmpOid stopOid) 
	throws SnmpStatusException {
	int counter = 0, totalCounter = 0;
	while(true) {
	    SnmpVarBindList result = getNext(session, list);
	    SnmpVarBind avar = result.getVarBindAt(0);
	    if(avar.hasVarBindException() || 
	       (avar.getOid().compareTo(stopOid)>= 0)) {
		text.append("*** MIB discovery completed\n");
		break;
	    }    

	    hookInTree(result);

	    list = result;
	    
	    counter ++;
	    
	    if(counter >= 100) {
		text.append("Processed [" + 
		    totalCounter +"] OID\n");
		counter = 0;
	    }
	    
	    totalCounter +=1;
	}
    }
    
    public void resync(SnmpOid startOid, SnmpOid stopOid) {
	Resync r = new Resync(startOid, stopOid, true);
	r.start();
    }

    public void resync() {		
	resync(start, stop);
    }
    
    public void partialResync(SnmpOid startOid, SnmpOid stopOid) {
	Resync r = new Resync(startOid, stopOid, false);
	r.start();
    }
    
    private void asyncResync(SnmpOid startOid, 
			     SnmpOid stopOid, 
			     boolean complete) {
	tree.setEditable(false);
	if(complete)
	    clear();
	
	try {
	    SnmpVarBindList vblst = new SnmpVarBindList();
	    
	    vblst.add(new SnmpVarBind(startOid));
	    vblst.add(new SnmpVarBind(stopOid));

	    doitWithGetNext(session,
			    vblst,
			    stopOid);
	}catch(Exception e) {
	    //e.printStackTrace();
	    text.append("Unexpected exception : ");
	    text.append(e.getMessage() + "\n");
	}
	text.append("*** Profile used [" + profile + "]\n");
	tree.setEditable(true);
    }
    
    public void display() {
	show();
    }
    
    public void close() {
	setVisible(false);
    }
    
    public void actionPerformed(ActionEvent e) {
	if(e.getSource() == resync)
	    resync();
	if(e.getSource() == close)
	    close();
	if(e.getSource() == menuItemOid)
	    showOid();
	if(e.getSource() == menuItemGet)
	    doGet();
	if(e.getSource() == menuItemSet)
	    doSet();
	if(e.getSource() == menuItemResync)
	    doResync();
    }
    
    public void doResync(){
	// TO CHANGE IN CASE OF MULTIPLE SELECTION OF GROUP AND TABLES...
	DefaultMutableTreeNode node = (DefaultMutableTreeNode)
	    tree.getLastSelectedPathComponent();
	DefaultTreeModel model = (DefaultTreeModel) tree.getModel();
	String strOid = null;
	
	if(node.getUserObject() instanceof GroupNode) {
	    GroupNode group = (GroupNode) node.getUserObject();
	    strOid = group.radical;
	    nodes.remove(group.radical);
	}
	
	if(node.getUserObject() instanceof TableNode) {
	    TableNode table = (TableNode) node.getUserObject();
	    GroupNode group = table.group;
	    strOid = group.radical + table.oid;
	    group.tables.remove(table.oid);
	}
	node.removeFromParent();
	// TO CHANGE IF A TABLE.
	model.reload();
	SnmpOid startOid = new SnmpOid(strOid);
	long[] st = startOid.longValue(true);
	st[st.length -1] = st[st.length -1] + 1;
	SnmpOid stopOid = new SnmpOid(st);
	//System.out.println("START OID : " + startOid);
	//System.out.println("STOP OID : " + stopOid);
	nodes.remove(startOid);
	partialResync(startOid, stopOid);
    }

    public void doGet() {
	Vector v = getSelected();
	//SnmpVarBindList list = constructVarBindList(v);
	//getFrame = new GetFrame(v, this);
	// DO A GET
    }

    public void doSet() {
	Vector v = getSelected();
	setFrame = new SetFrame(v, this);
    }
    
    private Vector getSelected() {
	Vector v = new Vector();
	TreePath[] nodes = tree.getSelectionPaths();
	for(int i = 0; i < nodes.length; i++) {
	    DefaultMutableTreeNode obj = 
		(DefaultMutableTreeNode) nodes[i].getLastPathComponent();
	    if(obj.getUserObject() instanceof OidNode)
		v.add(obj.getUserObject());
	}
	return v;
    }
    
    public void setValues(Vector rows) {
	for(Enumeration e = rows.elements(); e.hasMoreElements();) {
	    SetRow row = (SetRow)  e.nextElement();
	    java.lang.System.out.println(row.getValue() +"\n");
	}
	
	setFrame.hide();
	setFrame = null;

	//Compute set operation;
	//SnmpValue val = string2SnmpValue(
    }
    
    public void showOid() {
	Vector v = getSelected();
	text.append("-----------------------\n");
	for(Enumeration e = v.elements(); e.hasMoreElements();) {
	    Object obj = e.nextElement();
	    text.append(((OidNode) obj).name + " : " + 
			((OidNode) obj).oid + "\n"); 
	}
    }

    private String reconstructOid(String oid, int remove) {
	SnmpOid val = new SnmpOid(oid);
	long[] oidLong = val.longValue();
	SnmpOid ret = new SnmpOid();
	int size = oidLong.length - remove;
	
	for(int i = 0; i < size; i++)
	    ret.append(oidLong[i]);
	
	return ret.toString();
    }

    private boolean isEntry(String oid) {
	
	for(Enumeration e = m.metaFinder.entries.elements();
	    e.hasMoreElements();) {
	    String entry = ((SnmpOidRecord) e.nextElement()).getOid();
	    if(oid.startsWith(entry)) 
		return true;
	}
	return false;
    }

    public void processSnmpPollData(SnmpRequest request, int errStatus, int errIndex, SnmpVarBindList vblist) {
	
	int size = request.getResponseVarBindList().getVarBindCount();
	
	for (int i = 0; i < size; i++) {
	    SnmpVarBind b = request.getResponseVarBindList().getVarBindAt(i);
	    
	    String oid = b.getOid().toString();
	    //Look for groups radical
	    if(oid.endsWith(".0") && !isEntry(oid)) {
		String radical = reconstructOid(oid, 2);
		GroupNode node = (GroupNode) nodes.get(radical);
		if(node == null) {
		    text.append("New group : " + radical + "\n");
		    node = new GroupNode(this,
					 top, 
					 radical);
		    nodes.put(radical, node);
		}
		//else
		//  text.append("Already discovered group : " + radical + "\n");
		// Add oid in group
		node.addOid(oid, b.getSnmpValue());
	    } 
	    else {
		// Table processing
		for(Enumeration e = m.metaFinder.entries.elements();
		    e.hasMoreElements();) {
		    String entry = ((SnmpOidRecord) e.nextElement()).getOid();
		    if(oid.startsWith(entry)) {
			//Compute field
			long[] lentry = new SnmpOid(entry).longValue();
			long[] loid = b.getOid().longValue();
			long f = loid[lentry.length];
			long[] fieldOid = new long[lentry.length + 1];
			java.lang.System.arraycopy(lentry, 0, fieldOid, 0, lentry.length);
			fieldOid[lentry.length] = f;
			String field = new SnmpOid(fieldOid).toString();
			// Compute index
			int indexSize = loid.length - fieldOid.length;
			long[] lindex = new long[indexSize];
			for(int j= 0; j < indexSize; j++) {
			    lindex[j] = loid[fieldOid.length + j];
			}
			
			String index = new SnmpOid(lindex).toString();
			   
			//text.append("INDEX : " + index);
			
			//text.append("FIELD : " + field);
			
			String tableOid = reconstructOid(entry, 1);
			String groupOid = reconstructOid(entry, 2);
			GroupNode node = (GroupNode) nodes.get(groupOid);
			if(node == null) {
			    text.append("New group : " + groupOid + "\n");
			    node = new GroupNode(this,
						 top, 
						 groupOid);
			    nodes.put(groupOid, node);
			} 
			//else
			//  text.append("Already discovered group : " + groupOid + "\n");
			node.addEntry(tableOid, 
				      entry,
				      field,
				      index, 
				      b.getSnmpValue());
			break;
		    }
		}
	    }
	}
    }
}
