@echo off
::  ----------
:: | SETTINGS |
::  ----------

::  ---------------
:: | Java setting  |
::  ---------------
if defined java_home goto continue1

echo "Please set JAVA_HOME (JDK 1.4 or later) before launching the validator."
exit /B 1

:continue1

:: reset all var
set validation=
set schema=..\etc\mibvalidation.xsd
set debug=


::  ---------------
:: | JDMK setting  |
::  ---------------

set jdmk_home=..\..\..\

if defined jdmk_home goto continue2
echo "Please set JDMK_HOME (Java DMK install dir) before launching the validator."
exit /B 1
:continue2

if defined JAXP12_ENDORSED goto continue3
echo "Please set JAXP12_ENDORSED (jaxp/lib/endorsed dir from jwsdp 1.2 or later) before launching the validator."
exit /B 1

:continue3
set validator_home=..\

::  -----------------
:: | END OF SETTINGS |
::  -----------------

if not "%1"=="-help" goto Loop
	echo "Usage:"
	more ..\README
	exit /B 0

:Loop


IF "%1"=="" GOTO Continue

	IF "%1"=="-d" set debug=%2
	IF "%1"=="-validation" set validation=%2
	IF "%1"=="-schema" set schema=%2
SHIFT
GOTO Loop
:Continue


::  ----------------
:: | Jdmk jar files |
::  ----------------
:: mibvalidator jar file
set mibvalidator_jar=%validator_home%\lib\mibvalidator.jar

:: Jdmkrt jar file
set jdmk_rt_jar=%jdmk_home%\lib\jdmkrt.jar

:: jmx jar
set jmxri_jar=%jdmk_home%\lib\jmx.jar
set jmx_remote_jar=%jdmk_home%\lib\jmxremote.jar
set jmx_remote_optional_jar=%jdmk_home%\lib\jmxremote_optional.jar
set jmx_jar=%jmxri_jar%;%jmx_remote_jar%;%jmx_remote_optional_jar%


::  --------------
:: | Command line |
::  -------------- 

set classpath=%mibvalidator_jar%;%jmx_jar%;%jdmk_rt_jar%;%USER_CLASSPATH%
echo Running mibvalidator...
if defined debug ( 
"%java_home%/bin/java" -classpath %classpath% -Djava.endorsed.dirs=%JAXP12_ENDORSED% -DLEVEL_DEBUG -Djava.util.logging.config.file=..\etc\logging.properties validator.Validator %schema% %validation%  
) else ( 	
"%java_home%/bin/java" -classpath %classpath% -Djava.endorsed.dirs=%JAXP12_ENDORSED% validator.Validator %schema% %validation%  

)
:Finish
