/*
 * @(#)file      SnmpRfc2573ProxyManager.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.6
 * @(#)date      04/07/05
 *
 * Copyright 2000-2004 Sun Microsystems, Inc.  All rights reserved.
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 * 
 * Copyright 2000-2004 Sun Microsystems, Inc.  Tous droits r?serv?s.
 * Ce logiciel est propriet? de Sun Microsystems, Inc.
 * Distribu? par des licences qui en restreignent l'utilisation. 
 *
 */
package com.sun.management.snmp.rfc2573.manager.v3proxy;


// Util import
import java.util.Enumeration;

// JMX RI import
import com.sun.management.snmp.SnmpDefinitions;
import com.sun.management.snmp.SnmpStatusException;
import com.sun.management.snmp.manager.SnmpSession;
import com.sun.management.snmp.SnmpEngineId;

// JDMK import
import com.sun.jdmk.TraceManager;
import com.sun.jdmk.trace.Trace;

// Contrib MGR import
import com.sun.management.snmp.rfc2573.manager.internal.v3proxy.SnmpProxyHandler;
import com.sun.management.snmp.rfc2573.manager.internal.v3proxy.SnmpProxyData;

public class  SnmpRfc2573ProxyManager {

    /** 
     * Register Proxy
     */
    public static void registerProxy(SnmpSession session,
				     String proxyIndex, 
				     int requestType,
				     SnmpEngineId id,
				     String contextName,
				     String paramsIn,
				     String singleOut,
				     String multipleOut,
				     int storage) 
	throws SnmpStatusException {
	
	// new data to set in the MIB
	SnmpProxyData data = new SnmpProxyData();
	
	// Set the data to add
	data.proxyName = proxyIndex;
	data.type = requestType;
	data.contextEngineId = id;
	data.contextName = contextName;
	data.paramsIn = paramsIn;
	data.singleOut = singleOut;
	data.multipleOut = multipleOut;
	data.storageType = storage;

	SnmpProxyHandler.setProxy(session,
				  data);
    }

    public static void unregisterProxy(SnmpSession session,
				       String proxyIndex) 
	throws SnmpStatusException {
	SnmpProxyHandler.removeProxy(session,
				     proxyIndex);
    }
}
