package com.sun.management.snmp.rfc2573.notification.mib;

//
// Generated by mibgen version 5.0 (03/20/02) when compiling SNMP-NOTIFICATION-MIB in standard metadata mode.
//

// java imports
//
import java.io.Serializable;

// jmx imports
//
import javax.management.MBeanServer;
import com.sun.management.snmp.SnmpCounter;
import com.sun.management.snmp.SnmpCounter64;
import com.sun.management.snmp.SnmpGauge;
import com.sun.management.snmp.SnmpInt;
import com.sun.management.snmp.SnmpUnsignedInt;
import com.sun.management.snmp.SnmpIpAddress;
import com.sun.management.snmp.SnmpTimeticks;
import com.sun.management.snmp.SnmpOpaque;
import com.sun.management.snmp.SnmpString;
import com.sun.management.snmp.SnmpStringFixed;
import com.sun.management.snmp.SnmpOid;
import com.sun.management.snmp.SnmpNull;
import com.sun.management.snmp.SnmpValue;
import com.sun.management.snmp.SnmpVarBind;
import com.sun.management.snmp.SnmpStatusException;

// jdmk imports
//
import com.sun.management.snmp.agent.SnmpMib;
import com.sun.management.snmp.agent.SnmpMibGroup;
import com.sun.management.snmp.agent.SnmpStandardObjectServer;
import com.sun.management.snmp.agent.SnmpStandardMetaServer;
import com.sun.management.snmp.agent.SnmpMibSubRequest;
import com.sun.management.snmp.agent.SnmpMibTable;
import com.sun.management.snmp.EnumRowStatus;

/**
 * The class is used for representing SNMP metadata for the "SnmpNotifyObjects" group.
 * The group is defined with the following oid: 1.3.6.1.6.3.13.1.
 */
public class SnmpNotifyObjectsMeta extends SnmpMibGroup implements Serializable, SnmpStandardMetaServer {

    /**
     * Constructor for the metadata associated to "SnmpNotifyObjects".
     */
    public SnmpNotifyObjectsMeta(SnmpMib myMib, SnmpStandardObjectServer objserv) {
        objectserver = objserv;
        try {
            registerObject(3);
            registerObject(2);
            registerObject(1);
        } catch (IllegalAccessException e) {
            throw new RuntimeException(e.getMessage());
        }
    }

    /**
     * Get the value of a scalar variable
     */
    public SnmpValue get(long var, Object data)
        throws SnmpStatusException {
        switch((int)var) {
            case 3: {
                throw new SnmpStatusException(SnmpStatusException.noSuchInstance);
                }

            case 2: {
                throw new SnmpStatusException(SnmpStatusException.noSuchInstance);
                }

            case 1: {
                throw new SnmpStatusException(SnmpStatusException.noSuchInstance);
                }

            default:
                break;
        }
        throw new SnmpStatusException(SnmpStatusException.noSuchObject);
    }

    /**
     * Set the value of a scalar variable
     */
    public SnmpValue set(SnmpValue x, long var, Object data)
        throws SnmpStatusException {
        switch((int)var) {
            case 3: {
                throw new SnmpStatusException(SnmpStatusException.snmpRspNotWritable);
                }

            case 2: {
                throw new SnmpStatusException(SnmpStatusException.snmpRspNotWritable);
                }

            case 1: {
                throw new SnmpStatusException(SnmpStatusException.snmpRspNotWritable);
                }

            default:
                break;
        }
        throw new SnmpStatusException(SnmpStatusException.snmpRspNotWritable);
    }

    /**
     * Check the value of a scalar variable
     */
    public void check(SnmpValue x, long var, Object data)
        throws SnmpStatusException {
        switch((int) var) {
            case 3: {
                throw new SnmpStatusException(SnmpStatusException.snmpRspNotWritable);
                }

            case 2: {
                throw new SnmpStatusException(SnmpStatusException.snmpRspNotWritable);
                }

            case 1: {
                throw new SnmpStatusException(SnmpStatusException.snmpRspNotWritable);
                }

            default:
                throw new SnmpStatusException(SnmpStatusException.snmpRspNotWritable);
        }
    }

    /**
     * Allow to bind the metadata description to a specific object.
     */
    protected void setInstance(SnmpNotifyObjectsMBean var) {
        node = var;
    }


    // ------------------------------------------------------------
    // 
    // Implements the "get" method defined in "SnmpMibGroup".
    // See the "SnmpMibGroup" Javadoc API for more details.
    // 
    // ------------------------------------------------------------

    public void get(SnmpMibSubRequest req, int depth)
        throws SnmpStatusException {
        objectserver.get(this,req,depth);
    }


    // ------------------------------------------------------------
    // 
    // Implements the "set" method defined in "SnmpMibGroup".
    // See the "SnmpMibGroup" Javadoc API for more details.
    // 
    // ------------------------------------------------------------

    public void set(SnmpMibSubRequest req, int depth)
        throws SnmpStatusException {
        objectserver.set(this,req,depth);
    }


    // ------------------------------------------------------------
    // 
    // Implements the "check" method defined in "SnmpMibGroup".
    // See the "SnmpMibGroup" Javadoc API for more details.
    // 
    // ------------------------------------------------------------

    public void check(SnmpMibSubRequest req, int depth)
        throws SnmpStatusException {
        objectserver.check(this,req,depth);
    }

    /**
     * Returns true if "arc" identifies a scalar object.
     */
    public boolean isVariable(long arc) {

        return false;
    }

    /**
     * Returns true if "arc" identifies a readable scalar object.
     */
    public boolean isReadable(long arc) {

        return false;
    }

    /**
     * Return the name of the attribute corresponding to the SNMP variable identified by "id".
     */
    public String getAttributeName(long id)
        throws SnmpStatusException {
        switch((int)id) {
            case 3: {
                throw new SnmpStatusException(SnmpStatusException.noSuchInstance);
                }

            case 2: {
                throw new SnmpStatusException(SnmpStatusException.noSuchInstance);
                }

            case 1: {
                throw new SnmpStatusException(SnmpStatusException.noSuchInstance);
                }

            default:
                break;
        }
        throw new SnmpStatusException(SnmpStatusException.noSuchObject);
    }

    /**
     * Returns true if "arc" identifies a table object.
     */
    public boolean isTable(long arc) {

        switch((int)arc) {
            case 3:
                return true;
            case 2:
                return true;
            case 1:
                return true;
            default:
                break;
        }
        return false;
    }

    /**
     * Returns the table object identified by "arc".
     */
    public SnmpMibTable getTable(long arc) {

        switch((int)arc) {
            case 3:
                return tableSnmpNotifyFilterTable;
            case 2:
                return tableSnmpNotifyFilterProfileTable;
            case 1:
                return tableSnmpNotifyTable;
        default:
            break;
        }
        return null;
    }

    /**
     * Register the group's SnmpMibTable objects with the meta-data.
     */
    public void registerTableNodes(SnmpMib mib, MBeanServer server) {
        tableSnmpNotifyFilterTable = createSnmpNotifyFilterTableMetaNode("SnmpNotifyFilterTable", "SnmpNotifyObjects", mib, server);
        if ( tableSnmpNotifyFilterTable != null)  {
            tableSnmpNotifyFilterTable.registerEntryNode(mib,server);
            mib.registerTableMeta("SnmpNotifyFilterTable", tableSnmpNotifyFilterTable);
        }

        tableSnmpNotifyFilterProfileTable = createSnmpNotifyFilterProfileTableMetaNode("SnmpNotifyFilterProfileTable", "SnmpNotifyObjects", mib, server);
        if ( tableSnmpNotifyFilterProfileTable != null)  {
            tableSnmpNotifyFilterProfileTable.registerEntryNode(mib,server);
            mib.registerTableMeta("SnmpNotifyFilterProfileTable", tableSnmpNotifyFilterProfileTable);
        }

        tableSnmpNotifyTable = createSnmpNotifyTableMetaNode("SnmpNotifyTable", "SnmpNotifyObjects", mib, server);
        if ( tableSnmpNotifyTable != null)  {
            tableSnmpNotifyTable.registerEntryNode(mib,server);
            mib.registerTableMeta("SnmpNotifyTable", tableSnmpNotifyTable);
        }

    }


    /**
     * Factory method for "SnmpNotifyFilterTable" table metadata class.
     * 
     * You can redefine this method if you need to replace the default
     * generated metadata class with your own customized class.
     * 
     * @param tableName Name of the table object ("SnmpNotifyFilterTable")
     * @param groupName Name of the group to which this table belong ("SnmpNotifyObjects")
     * @param mib The SnmpMib object in which this table is registered
     * @param server MBeanServer for this table entries (may be null)
     * 
     * @return An instance of the metadata class generated for the
     *         "SnmpNotifyFilterTable" table (SnmpNotifyFilterTableMeta)
     * 
     **/
    protected SnmpNotifyFilterTableMeta createSnmpNotifyFilterTableMetaNode(String tableName, String groupName, SnmpMib mib, MBeanServer server)  {
        return new SnmpNotifyFilterTableMeta(mib, objectserver);
    }


    /**
     * Factory method for "SnmpNotifyFilterProfileTable" table metadata class.
     * 
     * You can redefine this method if you need to replace the default
     * generated metadata class with your own customized class.
     * 
     * @param tableName Name of the table object ("SnmpNotifyFilterProfileTable")
     * @param groupName Name of the group to which this table belong ("SnmpNotifyObjects")
     * @param mib The SnmpMib object in which this table is registered
     * @param server MBeanServer for this table entries (may be null)
     * 
     * @return An instance of the metadata class generated for the
     *         "SnmpNotifyFilterProfileTable" table (SnmpNotifyFilterProfileTableMeta)
     * 
     **/
    protected SnmpNotifyFilterProfileTableMeta createSnmpNotifyFilterProfileTableMetaNode(String tableName, String groupName, SnmpMib mib, MBeanServer server)  {
        return new SnmpNotifyFilterProfileTableMeta(mib, objectserver);
    }


    /**
     * Factory method for "SnmpNotifyTable" table metadata class.
     * 
     * You can redefine this method if you need to replace the default
     * generated metadata class with your own customized class.
     * 
     * @param tableName Name of the table object ("SnmpNotifyTable")
     * @param groupName Name of the group to which this table belong ("SnmpNotifyObjects")
     * @param mib The SnmpMib object in which this table is registered
     * @param server MBeanServer for this table entries (may be null)
     * 
     * @return An instance of the metadata class generated for the
     *         "SnmpNotifyTable" table (SnmpNotifyTableMeta)
     * 
     **/
    protected SnmpNotifyTableMeta createSnmpNotifyTableMetaNode(String tableName, String groupName, SnmpMib mib, MBeanServer server)  {
        return new SnmpNotifyTableMeta(mib, objectserver);
    }

    protected SnmpNotifyObjectsMBean node;
    protected SnmpStandardObjectServer objectserver = null;
    protected SnmpNotifyFilterTableMeta tableSnmpNotifyFilterTable = null;
    protected SnmpNotifyFilterProfileTableMeta tableSnmpNotifyFilterProfileTable = null;
    protected SnmpNotifyTableMeta tableSnmpNotifyTable = null;
}
