/*
 * @(#)file      SnmpTargetLcd.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.4
 * @(#)date      04/07/05
 *
 * Copyright 2000-2004 Sun Microsystems, Inc.  All rights reserved.
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 * 
 * Copyright 2000-2004 Sun Microsystems, Inc.  Tous droits r?serv?s.
 * Ce logiciel est propriet? de Sun Microsystems, Inc.
 * Distribu? par des licences qui en restreignent l'utilisation. 
 *
 */

package com.sun.management.snmp.rfc2573.target;

import java.util.Enumeration;

public interface SnmpTargetLcd {
    
    public void readConfiguration() throws Exception;

    public void removeTarget(String targetName) 
	  throws IllegalArgumentException;
    
    public void addTarget(String targetsName,
			  String domain,
			  Byte[] address,
			  int timeout,
			  int retry,
			  String tags,
			  String paramsName,
			  int storageType) throws IllegalArgumentException;

    public void addParams(String paramsName,
			  int mpm,
			  int securityModel,
			  String securityName,
			  int securityLevel,
			  int storageType) throws IllegalArgumentException;

    public void removeParams(String paramsName) 
	throws IllegalArgumentException;
    
    /**
     * Enumeration of <CODE>SnmpParamsData</CODE>
     */
    public Enumeration getParams();
    
    /**
     * Enumeration of <CODE>SnmpTargetsData</CODE>
     */
    public Enumeration getTargets();

    public SnmpParamsData getParams(String name);
    
    public SnmpTargetData getTarget(String name);
}
