/*
 * @(#)file      SnmpNotificationForwarder.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.5
 * @(#)date      04/07/05
 *
 * Copyright 2000-2004 Sun Microsystems, Inc.  All rights reserved.
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 * 
 * Copyright 2000-2004 Sun Microsystems, Inc.  Tous droits r?serv?s.
 * Ce logiciel est propriet? de Sun Microsystems, Inc.
 * Distribu? par des licences qui en restreignent l'utilisation. 
 *
 */
import com.sun.management.snmp.agent.SnmpTrapForwarder;
import com.sun.management.snmp.agent.SnmpTrap;
import com.sun.management.comm.SnmpV3AdaptorServer;
import com.sun.management.comm.SnmpAdaptorServer;
import com.sun.management.snmp.rfc2573.SnmpJdmkRfc2573NotificationOriginator;
import com.sun.management.snmp.SnmpPduTrap;
import com.sun.management.snmp.SnmpPduRequest;
import com.sun.management.snmp.SnmpScopedPduRequest;
import com.sun.management.snmp.SnmpVarBindList;
import com.sun.management.snmp.SnmpVarBind;
import com.sun.management.snmp.SnmpOid;

public class SnmpNotificationForwarder extends SnmpTrapForwarder {
    SnmpJdmkRfc2573NotificationOriginator sender = null;
    SnmpNotificationForwarder(SnmpV3AdaptorServer server, 
			      int port,
			      SnmpJdmkRfc2573NotificationOriginator sender) {
	super(server, port);
	this.sender = sender;
	receiveAsGeneric(false);
    }
    
    protected void receivedV1Trap(SnmpPduTrap trap) {
	java.lang.System.out.println("Received V1 trap : " + trap);
	int gen = trap.genericTrap;
	int specific = trap.specificTrap;
	SnmpVarBind[] arr = trap.varBindList;
	SnmpVarBindList lst = new SnmpVarBindList();
	for(int i = 0; i < arr.length; i++)
	    lst.addVarBind(arr[i]);
	try {
	    sender.snmpTrap(gen, specific, lst);
	}catch(Exception e) {
	    e.printStackTrace();
	}
    }
    
    protected void receivedV2Trap(SnmpPduRequest trap) {
	java.lang.System.out.println("Received V2 trap : " + trap);
	handleV2V3Trap(trap.varBindList, trap.community);
    }
    
    protected void receivedV3Trap(SnmpScopedPduRequest trap) {
	java.lang.System.out.println("Received V3 trap : " + trap);
	handleV2V3Trap(trap.varBindList, trap.contextName);
    }
    
    private void handleV2V3Trap(SnmpVarBind[] arr, byte[] ctx) {
	SnmpVarBindList lst = new SnmpVarBindList();
	SnmpOid trapOid = null;
	for(int i = 0; i < arr.length; i++) {
	    if(arr[i].getOid().equals(SnmpTrap.snmpTrapOid))
		trapOid = (SnmpOid) arr[i].getSnmpValue();
	    else
		lst.addVarBind(arr[i]);
	}
	try {
	    sender.snmpTrap(trapOid, lst, (ctx == null) ? null : new String(ctx));
	}catch(Exception e) {
	    e.printStackTrace();
	}
    }
}
